import { type IType, type Opt, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class IcrUserservermap {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  UserName?: string;
  UserId!: IType<number, bigint>;
  ServerId!: IType<number, bigint>;
  ExpireDate?: Date;
  Status!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
  ClassId!: IType<number, bigint> & Opt;
}

export const IcrUserservermapSchema = defineEntity({
  class: IcrUserservermap,
  comment: '学生和服务器的关系',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    UserName: p.string().name('UserName').nullable().comment('姓名'),
    UserId: p.bigint().name('UserId').columnType('bigint').comment('用户id'),
    ServerId: p.bigint().name('ServerId').columnType('bigint').comment('服务器id'),
    ExpireDate: p.datetime().name('ExpireDate').length(3).nullable().comment('过期时间(天)'),
    Status: p.integer().name('Status').comment('状态'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
    ClassId: p.bigint().name('ClassId').columnType('bigint').comment('班级id').defaultRaw(`0`),
  },
});
